/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>



extern GtkIconFactory* resources_factory;
GtkIconFactory* resources_factory = NULL;

#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_SUBTITLE "Photo Organizer"
#define RESOURCES_APP_VERSION _VERSION
#define RESOURCES_COPYRIGHT "Copyright 2009 Yorba Foundation"
#define RESOURCES_YORBA_URL "http://www.yorba.org"
#define RESOURCES_HELP_URL "http://trac.yorba.org/wiki/Shotwell"
#define RESOURCES_PREFIX _PREFIX
#define RESOURCES_LICENSE "\nShotwell is free software; you can redistribute it and/or modify it under the \nterms of the GNU Lesser General Public License as published by the Free \nSoftware Foundation; either version 2.1 of the License, or (at your option) \nany later version.\n\nShotwell is distributed in the hope that it will be useful, but WITHOUT \nANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS\nFOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for \nmore details.\n\nYou should have received a copy of the GNU Lesser General Public License \nalong with Shotwell; if not, write to the Free Software Foundation, Inc., \n51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA\n"
#define RESOURCES_CLOCKWISE "shotwell-rotate-clockwise"
#define RESOURCES_COUNTERCLOCKWISE "shotwell-rotate-counterclockwise"
#define RESOURCES_MIRROR "shotwell-mirror"
#define RESOURCES_CROP "shotwell-crop"
#define RESOURCES_REDEYE "shotwell-redeye"
#define RESOURCES_ADJUST "shotwell-adjust"
#define RESOURCES_PIN_TOOLBAR "shotwell-pin-toolbar"
#define RESOURCES_RETURN_TO_PAGE "shotwell-return-to-page"
#define RESOURCES_MAKE_PRIMARY "shotwell-make-primary"
#define RESOURCES_IMPORT "shotwell-import"
#define RESOURCES_IMPORT_ALL "shotwell-import-all"
#define RESOURCES_ICON_APP "shotwell.svg"
#define RESOURCES_ICON_ABOUT_LOGO "shotwell-street.jpg"
#define RESOURCES_ROTATE_CLOCKWISE_LABEL "Rotate"
#define RESOURCES_ROTATE_CLOCKWISE_TOOLTIP "Rotate the photo(s) right"
#define RESOURCES_ROTATE_COUNTERCLOCKWISE_LABEL "Rotate"
#define RESOURCES_ROTATE_COUNTERCLOCKWISE_TOOLTIP "Rotate the photo(s) left"
GFile* app_window_get_resources_dir (void);
void resources_add_stock_icon (GFile* file, const char* stock_id);
void resources_init (void);
void resources_terminate (void);
GFile* resources_get_ui (const char* filename);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp);
GdkPixbuf* resources_get_icon (const char* name, gint scale);

static const char* RESOURCES_AUTHORS[] = {"Jim Nelson <jim@yorba.org>", NULL};


#line 66 "Resources.vala"
void resources_init (void) {
#line 59 "Resources.c"
	GtkIconFactory* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* icons_dir;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	_tmp0_ = NULL;
#line 67 "Resources.vala"
	resources_factory = (_tmp0_ = gtk_icon_factory_new (), (resources_factory == NULL) ? NULL : (resources_factory = (g_object_unref (resources_factory), NULL)), _tmp0_);
#line 496 "AppWindow.vala"
	_tmp1_ = NULL;
#line 69 "Resources.vala"
	_tmp2_ = NULL;
#line 82 "Resources.c"
	icons_dir = (_tmp2_ = g_file_get_child (_tmp1_ = app_window_get_resources_dir (), "icons"), (_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL)), _tmp2_);
#line 948 "gio-2.0.vapi"
	_tmp3_ = NULL;
#line 70 "Resources.vala"
	resources_add_stock_icon (_tmp3_ = g_file_get_child (icons_dir, "object-rotate-right.svg"), RESOURCES_CLOCKWISE);
#line 88 "Resources.c"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_object_unref (_tmp3_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp4_ = NULL;
#line 71 "Resources.vala"
	resources_add_stock_icon (_tmp4_ = g_file_get_child (icons_dir, "object-rotate-left.svg"), RESOURCES_COUNTERCLOCKWISE);
#line 94 "Resources.c"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_object_unref (_tmp4_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp5_ = NULL;
#line 72 "Resources.vala"
	resources_add_stock_icon (_tmp5_ = g_file_get_child (icons_dir, "object-flip-horizontal.svg"), RESOURCES_MIRROR);
#line 100 "Resources.c"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_object_unref (_tmp5_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp6_ = NULL;
#line 73 "Resources.vala"
	resources_add_stock_icon (_tmp6_ = g_file_get_child (icons_dir, "crop.svg"), RESOURCES_CROP);
#line 106 "Resources.c"
	(_tmp6_ == NULL) ? NULL : (_tmp6_ = (g_object_unref (_tmp6_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp7_ = NULL;
#line 74 "Resources.vala"
	resources_add_stock_icon (_tmp7_ = g_file_get_child (icons_dir, "redeye.png"), RESOURCES_REDEYE);
#line 112 "Resources.c"
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_object_unref (_tmp7_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp8_ = NULL;
#line 75 "Resources.vala"
	resources_add_stock_icon (_tmp8_ = g_file_get_child (icons_dir, "adjust.png"), RESOURCES_ADJUST);
#line 118 "Resources.c"
	(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_object_unref (_tmp8_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp9_ = NULL;
#line 76 "Resources.vala"
	resources_add_stock_icon (_tmp9_ = g_file_get_child (icons_dir, "pin-toolbar.svg"), RESOURCES_PIN_TOOLBAR);
#line 124 "Resources.c"
	(_tmp9_ == NULL) ? NULL : (_tmp9_ = (g_object_unref (_tmp9_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp10_ = NULL;
#line 77 "Resources.vala"
	resources_add_stock_icon (_tmp10_ = g_file_get_child (icons_dir, "return-to-page.svg"), RESOURCES_RETURN_TO_PAGE);
#line 130 "Resources.c"
	(_tmp10_ == NULL) ? NULL : (_tmp10_ = (g_object_unref (_tmp10_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp11_ = NULL;
#line 78 "Resources.vala"
	resources_add_stock_icon (_tmp11_ = g_file_get_child (icons_dir, "make-primary.svg"), RESOURCES_MAKE_PRIMARY);
#line 136 "Resources.c"
	(_tmp11_ == NULL) ? NULL : (_tmp11_ = (g_object_unref (_tmp11_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp12_ = NULL;
#line 79 "Resources.vala"
	resources_add_stock_icon (_tmp12_ = g_file_get_child (icons_dir, "import.svg"), RESOURCES_IMPORT);
#line 142 "Resources.c"
	(_tmp12_ == NULL) ? NULL : (_tmp12_ = (g_object_unref (_tmp12_), NULL));
#line 948 "gio-2.0.vapi"
	_tmp13_ = NULL;
#line 80 "Resources.vala"
	resources_add_stock_icon (_tmp13_ = g_file_get_child (icons_dir, "import-all.png"), RESOURCES_IMPORT_ALL);
#line 148 "Resources.c"
	(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_object_unref (_tmp13_), NULL));
#line 82 "Resources.vala"
	gtk_icon_factory_add_default (resources_factory);
#line 152 "Resources.c"
	(icons_dir == NULL) ? NULL : (icons_dir = (g_object_unref (icons_dir), NULL));
}


#line 85 "Resources.vala"
void resources_terminate (void) {
#line 159 "Resources.c"
}


#line 88 "Resources.vala"
GFile* resources_get_ui (const char* filename) {
#line 165 "Resources.c"
	GFile* result;
	GFile* _tmp1_;
	GFile* _tmp0_;
	GFile* _tmp2_;
#line 88 "Resources.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 948 "gio-2.0.vapi"
	_tmp1_ = NULL;
#line 496 "AppWindow.vala"
	_tmp0_ = NULL;
#line 89 "Resources.vala"
	_tmp2_ = NULL;
#line 178 "Resources.c"
	result = (_tmp2_ = g_file_get_child (_tmp1_ = g_file_get_child (_tmp0_ = app_window_get_resources_dir (), "ui"), filename), (_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL)), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp2_);
	return result;
}


#line 92 "Resources.vala"
GdkPixbuf* resources_get_icon (const char* name, gint scale) {
#line 186 "Resources.c"
	GdkPixbuf* result;
	GError * _inner_error_;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* icons_dir;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp7_;
#line 92 "Resources.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 196 "Resources.c"
	_inner_error_ = NULL;
#line 496 "AppWindow.vala"
	_tmp0_ = NULL;
#line 93 "Resources.vala"
	_tmp1_ = NULL;
#line 202 "Resources.c"
	icons_dir = (_tmp1_ = g_file_get_child (_tmp0_ = app_window_get_resources_dir (), "icons"), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
	pixbuf = NULL;
	{
		char* _tmp3_;
		GFile* _tmp2_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 952 "gio-2.0.vapi"
		_tmp3_ = NULL;
#line 948 "gio-2.0.vapi"
		_tmp2_ = NULL;
#line 97 "Resources.vala"
		_tmp4_ = NULL;
#line 217 "Resources.c"
		_tmp5_ = (_tmp4_ = gdk_pixbuf_new_from_file (_tmp3_ = g_file_get_path (_tmp2_ = g_file_get_child (icons_dir, name)), &_inner_error_), _tmp3_ = (g_free (_tmp3_), NULL), (_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_object_unref (_tmp2_), NULL)), _tmp4_);
		if (_inner_error_ != NULL) {
			goto __catch45_g_error;
			goto __finally45;
		}
		_tmp6_ = NULL;
#line 97 "Resources.vala"
		pixbuf = (_tmp6_ = _tmp5_, (pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL)), _tmp6_);
#line 226 "Resources.c"
	}
	goto __finally45;
	__catch45_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 99 "Resources.vala"
			g_critical ("Resources.vala:99: Unable to load icon %s: %s", name, err->message);
#line 237 "Resources.c"
			(err == NULL) ? NULL : (err = (g_error_free (err), NULL));
		}
	}
	__finally45:
	if (_inner_error_ != NULL) {
		(icons_dir == NULL) ? NULL : (icons_dir = (g_object_unref (icons_dir), NULL));
		(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
#line 102 "Resources.vala"
	if (pixbuf == NULL) {
#line 251 "Resources.c"
		result = NULL;
		(icons_dir == NULL) ? NULL : (icons_dir = (g_object_unref (icons_dir), NULL));
		(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
		return result;
	}
	_tmp7_ = NULL;
#line 105 "Resources.vala"
	if (scale > 0) {
#line 260 "Resources.c"
		GdkPixbuf* _tmp8_;
		_tmp8_ = NULL;
#line 105 "Resources.vala"
		_tmp7_ = (_tmp8_ = scale_pixbuf (pixbuf, scale, GDK_INTERP_BILINEAR), (_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_object_unref (_tmp7_), NULL)), _tmp8_);
#line 265 "Resources.c"
	} else {
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp9_;
		_tmp10_ = NULL;
#line 105 "Resources.vala"
		_tmp9_ = NULL;
#line 105 "Resources.vala"
		_tmp7_ = (_tmp10_ = (_tmp9_ = pixbuf, (_tmp9_ == NULL) ? NULL : g_object_ref (_tmp9_)), (_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_object_unref (_tmp7_), NULL)), _tmp10_);
#line 274 "Resources.c"
	}
	result = _tmp7_;
	(icons_dir == NULL) ? NULL : (icons_dir = (g_object_unref (icons_dir), NULL));
	(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
	return result;
}


#line 108 "Resources.vala"
void resources_add_stock_icon (GFile* file, const char* stock_id) {
#line 285 "Resources.c"
	GError * _inner_error_;
	GdkPixbuf* pixbuf;
	GtkIconSet* icon_set;
#line 108 "Resources.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 108 "Resources.vala"
	g_return_if_fail (stock_id != NULL);
#line 293 "Resources.c"
	_inner_error_ = NULL;
	pixbuf = NULL;
	{
		char* _tmp0_;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 952 "gio-2.0.vapi"
		_tmp0_ = NULL;
#line 111 "Resources.vala"
		_tmp1_ = NULL;
#line 305 "Resources.c"
		_tmp2_ = (_tmp1_ = gdk_pixbuf_new_from_file (_tmp0_ = g_file_get_path (file), &_inner_error_), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
		if (_inner_error_ != NULL) {
			goto __catch46_g_error;
			goto __finally46;
		}
		_tmp3_ = NULL;
#line 111 "Resources.vala"
		pixbuf = (_tmp3_ = _tmp2_, (pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL)), _tmp3_);
#line 314 "Resources.c"
	}
	goto __finally46;
	__catch46_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 113 "Resources.vala"
			g_error ("Resources.vala:113: %s", err->message);
#line 325 "Resources.c"
			(err == NULL) ? NULL : (err = (g_error_free (err), NULL));
		}
	}
	__finally46:
	if (_inner_error_ != NULL) {
		(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	icon_set = gtk_icon_set_new_from_pixbuf (pixbuf);
#line 117 "Resources.vala"
	gtk_icon_factory_add (resources_factory, stock_id, icon_set);
#line 339 "Resources.c"
	(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
	(icon_set == NULL) ? NULL : (icon_set = (gtk_icon_set_unref (icon_set), NULL));
}




